<?php
/**
* delphiki @ http://www.lackofinspiration.com
*/

/**
 * Twitter OAuth class by Abraham Williams (abraham@abrah.am) http://abrah.am
 */
session_start();
require('twitterOAuth.php');
if($_REQUEST['oauth_token'] != NULL && $_SESSION['oauth_state'] === 'start'){
	$_SESSION['oauth_state'] = 'returned';
}
if(isset($_POST['consumer_key']) && isset($_POST['consumer_secret'])){
	$_SESSION['consumer_key'] = $_POST['consumer_key'];
	$_SESSION['consumer_secret'] = $_POST['consumer_secret'];
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
	<title>Get your Access Tokens easily</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"  />
</head>
<body>
	<h2>Get your Access Tokens easily</h2>
<?php 
if(!isset($_SESSION['consumer_key']) || !isset($_SESSION['consumer_secret'])){ 
	$_SESSION['oauth_state'] = 'start';
	?>
	<h3>Step 1</h3>
	<p>
		At first, follow <a href="https://twitter.com/oauth_clients">this link</a> and set the Callback URL of your application to : 
		<?php echo '<a href="'.$_SERVER['SCRIPT_URI'].'">'.$_SERVER['SCRIPT_URI'].'</a>'; ?>
	</p>
	<form action="?step=2" method="post">
		<p>
			<label for="consumer_key">Consumer Key :</label><br />
			<input type="text" name="consumer_key" id="consumer_key" size="60" /><br />
			<label for="consumer_secret">Consumer Secret :</label><br />
			<input type="text" name="consumer_secret" id="consumer_secret" size="60" /><br /><br />
			<input type="submit" value="Step 2" />
		</p>
	</form>
	<?php
} 
elseif(isset($_SESSION['consumer_key']) && isset($_SESSION['consumer_secret']) && $_SESSION['oauth_state'] === 'start'){
	$to = new TwitterOAuth($_SESSION['consumer_key'], $_SESSION['consumer_secret']);
  $tok = $to->getRequestToken();
	$_SESSION['request_key'] = $tok['oauth_token'];
	$_SESSION['request_secret'] = $tok['oauth_token_secret'];

	$request_link = $to->getAuthorizeURL($_SESSION['request_key']);
	?>
	<h3>Step 2</h3>
	<p>
		Follow <a href="<?php echo $request_link; ?>">this link</a> and allow your application to access your Twitter account.
	</p>
	<?php
}
elseif($_SESSION['oauth_state'] === 'returned' && $_GET['step'] != 'test'){
	if(!isset($_SESSION['access_key']) || !isset($_SESSION['access_secret'])){
		$to = new TwitterOAuth($_SESSION['consumer_key'], $_SESSION['consumer_secret'], $_SESSION['request_key'], $_SESSION['request_secret']);
		$tok = $to->getAccessToken();
		$_SESSION['access_key'] = $tok['oauth_token'];
		$_SESSION['access_secret'] = $tok['oauth_token_secret'];
	}
	?>
	<h3>Final Step</h3>
	<p>
		Here are your Access Key and Access Secret :
		<ul>
			<li>Access Key : <?php echo $_SESSION['access_key']; ?></li>
			<li>Access Secret : <?php echo $_SESSION['access_secret']; ?></li>
			<li>Consumer Key : <?php echo $_SESSION['consumer_key']; ?></li>
			<li>Consumer Secret : <?php echo $_SESSION['consumer_secret']; ?></li>
		</ul>
	</p>
	<p>
		Run a test ?
		<form action="?step=test" method="post">
			<p>
				<label for="message">Your message :</label><br />
				<textarea name="message" id="message" cols="50" rows="4"></textarea><br /><br />
				<input type="submit" />
			</p>
		</form>
	<?php
}
elseif(isset($_GET['step']) && $_GET['step'] == 'test'){
	$to = new TwitterOAuth($_SESSION['consumer_key'], $_SESSION['consumer_secret'], $_SESSION['access_key'], $_SESSION['access_secret']);
	$to->OAuthRequest('https://twitter.com/statuses/update.xml', array('status' => $_POST['message']),	'POST');
	?>
	<h3>Final step : test</h3>
	<p>
	 Check <a href="http://twitter.com/home">your Twitter account</a> to see if your message has been sent.
	</p>
	<p>
		Here are your Access Key and Access Secret :
		<ul>
			<li>Access Key : <?php echo $_SESSION['access_key']; ?></li>
			<li>Access Secret : <?php echo $_SESSION['access_secret']; ?></li>
			<li>Consumer Key : <?php echo $_SESSION['consumer_key']; ?></li>
			<li>Consumer Secret : <?php echo $_SESSION['consumer_secret']; ?></li>
		</ul>
	</p>	
	<?php
}?>
</body>
</html>